\prog;PicT675AD.asm| 16C675 avec affichage 8 bits srie
\b;Lit analo RA4 pin 3 et affiche en srie sur le registre 8 bits
.Proc	16F870
.Ref	12F675

\const;PortA|
bD	= 0
bCk	= 1
; AN3	= 4
DirA	= 2'011000	; RA4=AN3,  RA3 toujours In
DirC	= 0

SelAd3	= 2'00001101	;  AdCon0 mode Left justif  AN3   AdOn
ModeAnSel3	= 2'00101000	; Sel An3 sur RA4 pin 3, AD clock :8
; Slection des autres canaux avec AdCon0 et AnSel
SelAd0	=2'00000001	; RA0 pin 7
ModeAnSel0	= 2'00100001
SelAd1	=2'00000101	; RA1 pin 6
ModeAnSel1	= 2'00100010
SelAd2	=2'00001001	; RA2 pin 5
ModeAnSel2	= 2'00100100

.Loc	DebVar
C1:	.16	1
C2:	.16	1
Temp:	.16	1
Data:	.16	1

.Loc	0
Deb:
	Clr	PortA
	Move	#16'07,W
	Move	W,CmCon
	Set	Status:#RP0	; page 1
	Call	16'3FF
	Move	W,OscCal
	Move	#ModeAnSel3,W
	Move	W,AnSel
	Clr	Status:#RP0	; retour page 0

	Move	#DirA,W
	Move	W,TrisA
	Move	#DirC,W
	Move	W,TrisC

Loop:
	Move	#SelAd3,W
	Move	W,AdCon0
	Call	Del20
	Set	ADCon0:#Go
 W$:	TestSkip,BC ADCon0:#Go
	Jump	W$	; Attente fin
	Move	ADResH,W
	Call	SndS8
; Attente 0.2 sec
  A$:
	DecSkip,EQ	C1
	Jump	A$
	DecSkip,EQ	C2
	Jump	A$
	
	Jump	Loop
	
\rout:Del20| 20 \mu;s pour convertisseur AD
\mod:W
Del20:	Move	#6,W
 A$:	Add	#-1,W
	Skip,EQ
	Jump	A$
	Ret
	
\module;xRegSer|Registre srie jdn 030820
\macro;Registre  dcalage srie|
\b;Les transferts durent 85 us et ne doivent tre espacs
\b;de 1  10 ms au moins.
.Macro	SetD
	Set	PortA:#bD
	Nop
.EndMacro
.Macro	ClrD
	Clr	PortA:#bD
	Nop
.EndMacro

.Macro	SetCk
	Set	PortA:#bCk
.EndMacro
.Macro	ClrCk
	Clr	PortA:#bCk
.EndMacro
.Macro	FullCk	; Ck  .../'''\...
	SetCk
	Nop		; 1 \mu;s pulse min
	ClrCk
.EndMacro

\rout;SndS8|Envoie et lit 8 bits, sans Start/Stop=Ld
; Dure 85 microsecondes
\in;W  (data in)
\out;W = DataOut
\mod;W C1  Data
; CK  ________/'\\__/'\\__/'\\_... _/'\\_____
; Dout XXXXX\\_===\\_===\\_=== ... \\========
SndS8:
	Move	W,Data
	Move	#8,W
	Move	W,C1
  L$:
	ClrD
	RRC	Data
	Skip,CC
	SetD
	FullCk
	DecSkip,EQ C1
	Jump	L$
	Ret
; Fin du module xRegSer

.Align	16'8
.16	"P","i","c","t","6","7","5","a","d"
.Fill.16 	FinProg+1-APC,-1
.Loc	16'2007
.16	16'3F84	; Configuration	

.End
